//-----------------------------------------------------------------------------------//
//  DecalStayPlus.  An Update to Mongo's DecalStay Mod by MrLoathsome.    5/18/2018  //
//-----------------------------------------------------------------------------------//

class Ds extends UMenuModMenuItem;

var DecalTicker ticker;
var Int TM, MaxDecals;
var bool bExtendedDecals;
var bool bPermanentDecals;
var bool bNewPermanentDecals;
var bool bNewExtendedDecals;

function Setup()
{
	Super.Setup();
}

function Execute()
{
	MenuItem.Owner.Root.CreateWindow(class'DecalConfigWindow', 100, 100, 220, 200, MenuItem.Owner, true);
	if (class'DecalConfigClientWindow'.Default.bExtendedDecals)
	{
		if (ticker == None)
		{
			ticker = MenuItem.Owner.getEntryLevel().spawn(class'DecalTicker');
			ticker.decalhandler = self;
		}
	}
	bExtendedDecals = class'DecalConfigClientWindow'.Default.bExtendedDecals;
	bPermanentDecals = class'DecalConfigClientWindow'.Default.bPermanentDecals;
	MaxDecals = class'DecalConfigClientWindow'.Default.MaxDecals;
	TM = class'DecalConfigClientWindow'.Default.TimeMultiplier * 10;
}

function Tick(float deltaTime)
{
	local Scorch S;
	local int Dcount;

	bNewExtendedDecals = class'DecalConfigClientWindow'.Default.bExtendedDecals;
	if (bNewExtendedDecals != bExtendedDecals)
	{
		bExtendedDecals=bNewExtendedDecals;
	}
	if (!bExtendedDecals) return;
	if (!class'DecalConfigClientWindow'.Default.bPermanentDecals)
	{
		TM = class'DecalConfigClientWindow'.Default.TimeMultiplier * 10;
		bPermanentDecals = false;
	}
	else bPermanentDecals = true;

 	foreach MenuItem.Owner.getLevel().allactors(class'Scorch',S)
	{
		Dcount++;
		if ((S.TimerRate == 1.0) && (Dcount < MaxDecals) && (!S.bTimerLoop))
		{
			if (bPermanentDecals)
				{
					S.Disable('Timer');
					S.Lifespan = 0.0;
				}
			else
				{
					S.Lifespan = TM;
					S.Disable('Timer');
				}
			S.TimerRate = 0.0;
		}
		else if ((S.TimerRate == 0.0) && (S.LifeSpan != 0) && (S.LifeSpan < 1))
		{
			S.SetTimer(S.LifeSpan, false);
			S.LifeSpan = 0.0;
			S.Enable('Timer');
		}
	}
}

defaultproperties
{
     MenuCaption="Configure &DecalStayPlus"
     MenuHelp="Make decals last a configurable length of time"
}
